{*******************************************************}
{                                                       }
{       Alex Ghost Library                              }
{                                                       }
{       Copyright (c) 1999,2000 Alexey Popov            }
{                                                       }
{*******************************************************}

{$I AG.INC}

unit agRegistry;

interface

uses Registry;

type
  TagRegistry = class(TRegistry)
  public
    function ReadStringDef(Name: string; DefValue: string): string;
    function ReadIntegerDef(Name: string; DefValue: integer): integer;
    function ReadBoolDef(Name: string; DefValue: boolean): boolean;
  end;

implementation

function TagRegistry.ReadStringDef(Name: string; DefValue: string): string;
begin
  try
    Result:=ReadString(Name);
  except
    Result:=DefValue;
  end;
end;

function TagRegistry.ReadIntegerDef(Name: string; DefValue: integer): integer;
begin
  try
    Result:=ReadInteger(Name);
  except
    Result:=DefValue;
  end;
end;

function TagRegistry.ReadBoolDef(Name: string; DefValue: boolean): boolean;
begin
  try
    Result:=ReadBool(Name);
  except
    Result:=DefValue;
  end;
end;

end.
