{*******************************************************}
{                                                       }
{       Alex Ghost Library                              }
{                                                       }
{       Copyright (c) 1999,2000 Alexey Popov            }
{                                                       }
{*******************************************************}

{$I AG.INC}

unit agVCLReg;

interface

procedure Register;

implementation

uses
  Classes, agControls, agThread, agProgress, agStatus, agURLLabel, agDragDrop,
  {$IFDEF D4}agMenuBar,{$ENDIF} agControlBar, agToolButton, ComCtrls, dsgnintf,
  Controls, agCaptProp, agTranslator, agMailBox, agComCtrls, agFoldMon;

{$R agVCL.dcr}

type
  TToolbarEditor = class(TComponentEditor)
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
    procedure DoNewButton;
    procedure DoNewTagButton;
    procedure DoNewSeparator;
  end;

{ TToolbarEditor }

procedure TToolbarEditor.DoNewButton;
var
  B: TToolButton;
  Toolbar: TToolbar;
begin
  if Component is TToolButton then
    Toolbar:=((Component as TToolButton).Parent as TToolbar)
  else
    Toolbar:=(Component as TToolbar);
  B:=TToolButton(Designer.CreateComponent(TToolButton,Component,0,0,0,0));
  B.Top:=Toolbar.Buttons[Toolbar.ButtonCount-1].Top+1;
  B.Left:=Toolbar.Buttons[Toolbar.ButtonCount-1].Left+1;
end;

procedure TToolbarEditor.DoNewSeparator;
var
  B: TToolButton;
  Toolbar: TToolbar;
begin
  if Component is TToolButton then
    Toolbar:=((Component as TToolButton).Parent as TToolbar)
  else
    Toolbar:=(Component as TToolbar);
  B:=TToolButton(Designer.CreateComponent(TToolButton,Component,0,0,0,0));
  B.Style:=tbsSeparator;
  B.Width:=0;
  B.Height:=0;
  B.Top:=Toolbar.Buttons[Toolbar.ButtonCount-1].Top+1;
  B.Left:=Toolbar.Buttons[Toolbar.ButtonCount-1].Left+1;
end;

procedure TToolbarEditor.DoNewTagButton;
var
  B: TagToolButton;
  Toolbar: TToolbar;
begin
  if Component is TToolButton then
    Toolbar:=((Component as TToolButton).Parent as TToolbar)
  else
    Toolbar:=(Component as TToolbar);
  B:=TagToolButton(Designer.CreateComponent(TagToolButton,Component,0,0,0,0));
  B.Top:=Toolbar.Buttons[Toolbar.ButtonCount-1].Top+1;
  B.Left:=Toolbar.Buttons[Toolbar.ButtonCount-1].Left+1;
end;

procedure TToolbarEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: DoNewButton;
    1: DoNewTagButton;
    2: DoNewSeparator;
  end;
  Designer.Modified;
end;

function TToolbarEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result:='New ToolB&utton';
    1: Result:='New &agToolButton';
    2: Result:='New Se&parator';
  end;
end;

function TToolbarEditor.GetVerbCount: Integer;
begin
  Result:=3;
end;

procedure Register;
const
  ControlsPage = 'AGL';
begin
  RegisterComponents(ControlsPage, [TagThread]);
  RegisterComponents(ControlsPage, [TagProgress]);
  RegisterComponents(ControlsPage, [TagStatusPanel]);
  RegisterComponents(ControlsPage, [TagURLLabel]);
  RegisterComponents(ControlsPage, [TagDropFileSource, TagDropTextSource]);
  RegisterComponents(ControlsPage, [TagDropFileTarget, TagDropTextTarget]);
  RegisterComponents(ControlsPage, [TagCheckBox, TagRadioButton{, TagComboBox}]);
  {$IFDEF D4}
  RegisterComponents(ControlsPage, [TagMenuBar]);
  TagMenuBar.RemovePublished;
  {$ENDIF}
  RegisterComponents(ControlsPage, [TagControlBar, TagToolButton]);
  RegisterComponents(ControlsPage, [TagListView]);
  RegisterComponents(ControlsPage, [TagTranslator]);
  RegisterComponents(ControlsPage, [TagMailBoxManager]);
  RegisterComponents(ControlsPage, [TagFolderMonitor]);
//  RegisterComponentEditor(TToolbar, TToolbarEditor);
//  RegisterComponentEditor(TToolButton, TToolbarEditor);
//  RegisterComponentEditor(TagToolButton, TToolbarEditor);
  RegisterPropertyEditor(TypeInfo(TCaption), TagCheckBox, 'Caption', TagCaptionProperty);
  RegisterPropertyEditor(TypeInfo(TCaption), TagRadioButton, 'Caption', TagCaptionProperty);
end;

end.
